#include <iostream>  
#include <assert.h>  
using namespace std;


void mess_with_call_stack(double p, double q, double r, double s)
{

	p = p * r * s;
}


float* float_adder_bad(float a, float b)
{
	float c = a + b;

	return &c;
}

float* float_adder(float a, float b)
{
	float *p = new float;
	assert(p != NULL);
        *p = a + b;

	return p;
}

int main(int argc, char **argv)
{
	float x = 10.0;	
	float y = 123.4;	


	/* This is bad because we get a memory address that is to a local variable, which no longer "exists", because the variable was on the stack, and the stack gets re-used. */
	float *bad = float_adder_bad(x, y);
	cout << " Result (as addr)= " << bad << endl;
	cout << " Result = " << *bad << endl;
	mess_with_call_stack(8.6, 3.5, 6.7, 13.45);
	cout << " Result (as addr)= " << bad << endl;
	cout << " Result = " << *bad << endl;

	float *dynfloat = float_adder(x, y);
	cout << " Result (as addr)= " << dynfloat << endl;
	cout << " Result = " << *dynfloat << endl;
	delete dynfloat;
	cout << " dynfloat after delete = " << dynfloat << endl;
	cout << " deref dynfloat after delete = " << *dynfloat << endl;
	float *dynfloat2 = float_adder(2.0*x, y);
	cout << " Result (as addr)= " << dynfloat2 << endl;
	cout << " Result = " << *dynfloat2 << endl;
	delete dynfloat2;

	for (int i  = 0 ; i < 10; i++)
	{

		dynfloat = float_adder(((float)i)*x, y);
		delete dynfloat;
	}

	cout << " Post loop result = " << *dynfloat << endl;
	return 0;
}

